// Injecting a dll in a target address space example
//
// By: isildur, December 2002 for anticrack.de
//
// email: v_d_d@yahoo.com
// web:   http://www.geocities.com/v_d_d
//
// You will also need the code for the inject.dll that this loader needs
//
//
// Warning: This code is just an example. There is almost no error checking
//          to make things simple. You will need to check the return values
//          of every function if you want to use this code for something robust.
//////////////////////////////////////////////////////////////////////////////////


#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <string.h>
#include "notepadLoaderres.h"

typedef int (WINAPI* TDefSetHook)(DWORD threadID, HWND hwnd);
typedef void (WINAPI* TDefUnsetHook)(void);

HWND notepadHwnd;
DWORD notepadThreadID;
STARTUPINFO si;
PROCESS_INFORMATION pi;
HMODULE ourDll;

BOOL hookPresent = 0;

// our dll function pointers
TDefSetHook DLLSetHook;
TDefUnsetHook DLLUnsetHook;

// prototypes
static BOOL CALLBACK DialogFunc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam);
int loadNotepad(void);
void cleanUp(void);



int APIENTRY WinMain(HINSTANCE hinst, HINSTANCE hinstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	WNDCLASS wc;

	memset(&wc,0,sizeof(wc));
	wc.lpfnWndProc = DefDlgProc;
	wc.cbWndExtra = DLGWINDOWEXTRA;
	wc.hInstance = hinst;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
	wc.lpszClassName = "notepadLoader";
	RegisterClass(&wc);

	return DialogBox(hinst, MAKEINTRESOURCE(DLG_100), NULL, (DLGPROC) DialogFunc);
}


static int InitializeApp(HWND hDlg,WPARAM wParam, LPARAM lParam)
{
	int retVal;

	// load notepad
	retVal = loadNotepad();

	if(!retVal)
		return 0;

	// load our dll
	ourDll = LoadLibrary("inject.dll");

	if(!ourDll)
	{
		return 0;
	}

	// get the address of our SetHook function in our dll
	DLLSetHook = (TDefSetHook) GetProcAddress(ourDll, "SetHook");

	// get the address of our SetHook function in our dll
	DLLUnsetHook = (TDefUnsetHook) GetProcAddress(ourDll, "UnsetHook");

	// get notepad's main window handle using class name
	notepadHwnd = FindWindow("Notepad", NULL);

	// get notepad's thread ID
	notepadThreadID = GetWindowThreadProcessId(notepadHwnd, NULL);

	// now set the hook
	retVal = DLLSetHook(notepadThreadID, notepadHwnd);

	return retVal;
}


int loadNotepad(void)
{
	int retVal;


	si.cb = sizeof(STARTUPINFO);

	si.lpDesktop = NULL;
	si.lpTitle = NULL;
	si.dwFillAttribute = 0;
	si.dwX = 0;
	si.dwXCountChars = 0;
	si.dwXSize = 0;
	si.dwY = 0;
	si.dwYCountChars = 0;
	si.dwYSize = 0;
	si.wShowWindow = 0;
	si.dwFlags = 0;
	si.hStdError = 0;
	si.hStdInput = 0;
	si.hStdOutput = 0;
	si.cbReserved2 = 0;
	si.lpReserved = NULL;
	si.lpReserved2 = NULL;

	retVal = CreateProcess( NULL,
							"notepad.exe",
							NULL,
							NULL,
							FALSE,                      // handle inheritance option
							NORMAL_PRIORITY_CLASS,                     // creation flags
							NULL,                      // new environment block
							NULL,                // current directory name
							&si,
							&pi);


	if(retVal)
		// wait for notepad to finish loading
		WaitForInputIdle(pi.hProcess, 10000);
	else
		{
			retVal = GetLastError();

			return 0;
		}
	return 1;
}



static BOOL CALLBACK DialogFunc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
		case WM_INITDIALOG:
		{
			hookPresent = InitializeApp(hwndDlg,wParam,lParam);
			if(!hookPresent)
				MessageBox(NULL, "Error setting hook!", "Error", MB_ICONERROR);
		}
		return TRUE;

		case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
				case IDOK:
					EndDialog(hwndDlg,1);
				return 1;
				case IDCANCEL:
					cleanUp();
					EndDialog(hwndDlg,0);
				return 1;
			}
		}
		break;

		case WM_CLOSE:
			cleanUp();
			EndDialog(hwndDlg,0);
		return TRUE;
	}

	return FALSE;
}

void cleanUp(void)
{
	if(hookPresent)
	{
		DLLUnsetHook();
	}
}
